---------------------
-- Library calling --
---------------------
--Call the ACE Libraries
local MBPNbattle = LibStub("AceGUI-3.0")
--local AceGUI = LibStub("AceGUI-3.0")
local MBPNCbattle = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(MBPNCbattle)

-------------------------------------------------------------------------------
----------------------
-- local definitons --
----------------------
MBPNbattleEnable = true
local battleFrame = battleFrame or {}
local battleScrollContainer = {}--battleScrollContainer
local battleScroll = {}--battleScroll
local battleLabel = {}--battleLabel
local battleButton1 = {}--battleButton1
local battleButton2 = {}--battleButton2
local captureButton = {}
local soundHorn = {}
local thisBattle = {}
local allBattles = {}
-------------------------------------------------------------------------------
-------------------
-- clear filters --
-------------------


function ClearFilters()
   p = C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   
end



function ParseGUID(guid,name)
   local first3 = tonumber("0x"..strsub(guid, 3,5))
   local unitType = bit.band(first3,0x00f)
   if (unitType == 0x000) then
      print("Player, ID #", strsub(guid,6))
   elseif (unitType == 0x003) then
      local creatureID = tonumber("0x"..strsub(guid,7,10))
      local spawnCounter = tonumber("0x"..strsub(guid,11))
      return creatureID
   end
end
function GetGUID()
   thisBattle = {}
   thisBattle.loc = {}
   thisBattle.pets = {}
   thisBattle.pets.pet = {}
   local guid = UnitGUID("target")
   local name = GetUnitName("target")
   local unitX, unitY = GetPlayerMapPosition("player")
   unitX=tonumber(strsub(unitX,0,6))*100
   unitY=tonumber(strsub(unitY,0,6))*100
   if guid then 
      local creatureID=ParseGUID(guid,name)
      --print(name,unitX,unitY,creatureID)
      thisBattle.guid = guid
      thisBattle.name = name
      local continentID = GetCurrentMapContinent()
      local continent = GetContinentByID(continentID)
      local zoneID = GetCurrentMapZone()
      local zone = GetZoneByID(continentID,zoneID)
      thisBattle.creatureID = creatureID
      thisBattle.continentid = continentID
      thisBattle.continent = continent
      thisBattle.zone = zone
      thisBattle.zoneid = zoneID
      thisBattle.areaid = GetCurrentMapAreaID()
      thisBattle.loc.x = unitX
      thisBattle.loc.y = unitY
   end
end
--SLASH_UNIT1='/unit'
--SlashCmdList["UNIT"]=GetGUID


-------------------------------------------------------------------------------
--------------------------------
-- Code for pet battle Window --
--------------------------------
local released = false

function quitBattle(widget)
   p = C_PetBattles
   p.ForfeitGame(true)
   if not MBPNbattle then return end
   if not released then
      battleFrame:Release(widget)
      released = true
   end
end


function MBPNCbattle:PetBattleEnd()
   PetDownloader_Download()
   
   if not MBPNbattle then return end
   if not battleFrame then return end
   if not released then
      battleFrame:Release(widget)
      released = true
   end
end
function OpenSearchWindow(button)
   MBPNCsearch:MBPNsearchWindow("")
end

function CreateBattleWindow()
   if not MBPNbattleEnable then return end
   released = false
   battleFrame = MBPNbattle:Create("Frame")
   battleScrollContainer = MBPNbattle:Create("SimpleGroup")
   battleScroll = MBPNbattle:Create("ScrollFrame")
   battleButton1 = MBPNbattle:Create("Button")
   battleButton2 = MBPNbattle:Create("Button")
   battleFrame:SetTitle("My Battle Pet Notifier")
   battleFrame:SetStatusText("PetBattle!")
   battleFrame:SetWidth(350)
   battleFrame:SetHeight(400)
   battleFrame:SetPoint("LEFT",nil,"LEFT")
   battleFrame:SetLayout("List")
   battleFrame:SetCallback("OnClick", function() released = true; end)
   --scroll props
   battleScroll:SetLayout("List")
   
   --button1 props
   battleButton1:SetText("Quit Battle")
   battleButton1:SetWidth(175)
   battleButton1:SetCallback("OnClick", function(widget) quitBattle(widget) end)
   --button2 props
   battleButton2:SetText("Toggle Search Window")
   battleButton2:SetWidth(200)
   battleButton2:SetCallback("OnClick", function(button) OpenSearchWindow(button) end)
   
   -- 
   
   --scrollcontainer props
   battleScrollContainer:SetFullWidth(true)
   battleScroll:SetFullWidth(true)
   battleScroll:SetHeight(700)
   battleScrollContainer:SetHeight(275)
   battleScrollContainer:SetFullHeight(true)
   battleScrollContainer:SetLayout("Fill")
   battleFrame:AddChild(battleButton2)
   battleFrame:AddChild(battleScrollContainer)
   battleScrollContainer:AddChild(battleScroll)
   battleFrame:AddChild(battleButton1)
end

function MBPNCbattle:PetChanged(event,y)
   if not MBPNbattle then return end
   if y == 2 then
      local b = C_PetBattles
      local c = b.GetActivePet(y)
      local r = b.GetBreedQuality(y,c)
      local n = b.GetName(y,c)
      local l = b.GetLevel(y,c)
      battleFrame:SetStatusText("("..l..") "..rarityColor[r]..n)
   end
end
function MBPNCbattle:PetCaptured(event,y)
   local b = C_PetBattles
   local x = b.GetActivePet(y)
   captureButton[x]:SetText("Trapped!")
   for i=1,b.GetNumPets(2) do 
      captureButton[x]:SetDisabled(true)
   end
end

function MBPNCbattle:PetHealthChanged(event,y) 
   local b = C_PetBattles
   local x = b.GetActivePet(2)
   for i=1,b.GetNumPets(2) do 
      if b.IsTrapAvailable()==true and i==x then
         captureButton[x]:SetDisabled(true) 
      else
         captureButton[x]:SetDisabled(false)
      end
   end
end

function MBPNCbattle:TurnStarted(event,y) 
   local b = C_PetBattles
   local x = b.GetActivePet(2)
   for i=1,b.GetNumPets(2) do 
      if b.IsTrapAvailable()==true and i==x then
         captureButton[x]:SetDisabled(true) 
      else
         captureButton[x]:SetDisabled(false)
      end
   end
end
function UseTrap(self,event,button)
   b=C_PetBattles
   b.UseTrap()
end
function MBPNCbattle:OnEnter(event,petID)
   
end

function MBPNCbattle:PetBattleStart(event,...) 
   PetDownloader_Download()
   GetGUID()
   released = false
   local rareNeeded = false
   if not MBPNbattleEnable then return end
   local wild = C_PetBattles.IsWildBattle()
   p = C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   q = {}
   CreateBattleWindow()
   for i=1,C_PetBattles.GetNumPets(2) do
      local RareNeeded = false
      c = 0
      petCount = 0
      quality = 0
      thisBattle.pets.pet[i] = {}
      lvl = C_PetBattles.GetLevel(2,i)
      o =  C_PetBattles.GetName(2,i)
      local Quality = C_PetBattles.GetBreedQuality(2,i)
      local type=C_PetBattles.GetPetType(2,i)
      
      thisBattle.pets.pet[i].name = o
      thisBattle.pets.pet[i].level = lvl
      thisBattle.pets.pet[i].rarity = Quality
      
      battleLabel = MBPNbattle:Create("InteractiveLabel")
      battleLabel:SetFullWidth(true)
      battleLabel:SetFont("Fonts\\FRIZQT__.TTF",14)
      battleLabel:SetImage(C_PetBattles.GetIcon(2,i))
      battleLabel:SetText("|cFFf9eb77 Wild Pet "..i..":|r "..rarityColor[Quality]..C_PetBattles.GetName(2,i).."|r (L"..lvl..")|n"..creature[type]..": Use "..weakness[type].." abilities not "..strength[type].." abilities|n"..creature[weakness[creature[type]]].." takes extra damage and "..creature[strength[creature[type]]].." takes less")
      battleScroll:AddChild(battleLabel)
      captureButton[i] = MBPNbattle:Create("InteractiveLabel")
      captureButton[i]:SetText("Capture")
      captureButton[i]:SetDisabled(true)
      captureButton[i]:SetFullWidth(true)
      captureButton[i]:SetImage([[INTERFACE\ICONS\INV_Pet_PetTrap02.blp]])
      captureButton[i]:SetImageSize(32,32)
      captureButton[i]:SetCallback("OnClick", function(widget) UseTrap(widget) end)
      for j=1, # PetDownloader do
         local id=tonumber(PetDownloader["petid"][j])
         local level=PetDownloader["level"][j]
         local n=PetDownloader["name"][j]
         id = tonumber(id)
         if not id or id== nil then id= 0 end
         if id > 0 and n == o then
            local r=PetDownloader["rarity"][j]
            if r and Quality > 3 and Quality > r then 
               RareNeeded = true 
               soundHorn[i] = true
            end
            if r and r > 3 then 
               RareNeeded = false 
               soundHorn[i] = false
            end
            c = c + 1;
            battleLabel = MBPNbattle:Create("InteractiveLabel")
            battleLabel:SetFullWidth(true)
            battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
            battleLabel:SetImage(icon)
            local lnk = rarityColor[r]..n.."|r"
            --print(id,level,lnk)
            battleLabel:SetText("You have: "..lnk.."|r (L"..level..")")
            if wild then battleScroll:AddChild(battleLabel) end
         end
      end
      if c == 0 then
         battleLabel = MBPNbattle:Create("Label")
         battleLabel:SetFullWidth(true)
         battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
         battleLabel:SetText("You have no "..rarityColor[0]..o.."|r!")
         if Quality > 3 then soundHorn[i] = true end
         if wild then battleScroll:AddChild(battleLabel) end
         RareNeeded=true
      end
      battleLabel = MBPNbattle:Create("Label")
      battleLabel:SetFullWidth(true)
      battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
      battleLabel:SetText(" ")
      battleScroll:AddChild(battleLabel)
      if rareNeeded == false and RareNeeded == true then 
         rareNeeded = true 
         if wild then if c < 3 then battleScroll:AddChild(captureButton[i]) end end
      end
      --battleScroll:AddChild(captureButton[i])
   end
   if soundHorn[1] == true or soundHorn[2] == true or soundHorn[3] == true then
      if wild then 
         PlaySoundFile([[Sound\Events\scourge_horn.wav]],"Master") 
         battleButton1:SetDisabled(true)
         soundHorn[1]=false 
         soundHorn[2]=false 
         soundHorn[3]=false 
      end
   end
   table.insert(petBattles,thisBattle)
end

function MBPNCbattle:LoadBattles() 
   petBattles=_G.petBattles
   if not petBattles then petBattles = {} end
end

function MBPNCbattle:PetDB(msg) 
   if strlower(msg) == "clear" then
      petBattles = {}
   end
end

------------------------------------------
-- Events and slash command registering --
------------------------------------------

MBPNCbattle:RegisterEvent("PET_BATTLE_OPENING_START","PetBattleStart")
MBPNCbattle:RegisterEvent("PET_BATTLE_CLOSE","PetBattleEnd")
MBPNCbattle:RegisterEvent("PET_BATTLE_PET_CHANGED","PetChanged")
MBPNCbattle:RegisterEvent("PET_BATTLE_CAPTURED","PetCaptured")
MBPNCbattle:RegisterEvent("PET_BATTLE_HEALTH_CHANGED","PetHealthChanged")
MBPNCbattle:RegisterEvent("PET_BATTLE_TURN_STARTED","TurnStarted")
MBPNCbattle:RegisterEvent("VARIABLES_LOADED","LoadBattles")

MBPNCbattle:RegisterChatCommand("petdb", "PetDB")